package uoc.ei.ejemplos.modulo4;

import java.io.IOException;
import java.util.StringTokenizer;
import uoc.ei.tads.ArbolBinarioEncadenadoImpl;
import uoc.ei.tads.ArbolGeneralDelegImpl;
import uoc.ei.tads.Pila;
import uoc.ei.tads.PilaVectorImpl;
import uoc.ei.tads.Posicion;
import uoc.ei.tads.Utilidades;

public class ArbolLocalizaciones extends ArbolGeneralDelegImpl<String> {

	
	public ArbolLocalizaciones() {
		super();
	}
	
	
	public ArbolLocalizaciones(String arbolEnTexto) {
		super();
		leer(arbolEnTexto);
	}
	
	
	protected void leer(String arbreEnText) {
		Pila<Posicion<String>> antecesores=new PilaVectorImpl<Posicion<String>>();
		StringTokenizer tokenizer=new StringTokenizer(arbreEnText);
		// cogemos el nmero de la raz y creamos el nodo raz
		String nombre=tokenizer.nextToken();
		Posicion<String> posicionActual=insertar(null,nombre);
		while (tokenizer.hasMoreTokens()) {
			nombre=tokenizer.nextToken();
			if (nombre.equals("SUB"))
				antecesores.apilar(posicionActual);
			else if (nombre.equals("FSUB"))
				antecesores.desapilar();
			else {
				Posicion<String> padre=antecesores.cima();
				posicionActual=insertar(padre,nombre);
			}
		}
	}
	
	
	public static void main(String args[]) {
		ArbolLocalizaciones arbre=new ArbolLocalizaciones("Catalunya SUB VallsOriental SUB Montmel FSUB Barcelons SUB Barcelona SUB NouBarris Carmel Grcia Sarri FSUB LHospitalet FSUB Bages");
		System.out.println("El rbol resultante es: "+arbre);
	}
	
}
