package uoc.ei.ejemplos.modulo9.dns;

/**
 * Clase que contiene la informacin que define el nombre de un host (ej: "www"). 
 * @author David Fguls
 * @author Jordi Alvarez (adaptacin para la versin 2.0.0 de la librera)
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */
public class Host implements Comparable{
  private String host;
  
  /**
   * Constructor de un host a partir de una cadena (ej "www").
   * @param s cadena que contiene el nombre del hueste (ej "ww").
   */
  public Host(String s) {
    host=s;
  }

  /**
   * Mtodo que permite comparar dos hosts. Necesario para poder aadir hosts al contenedor de hosts.
   * @param o otro host.
   */
  public int compareTo(Object o) {
    Host h=(Host)o;
    return host.compareTo(h.host);
  }
  
  /**
   * Mtodo que retorna una cadena con el nombre del host.
   * @return String cadena con el nombre del host (ej "www").
   */
  public String toString() {
    return host;
  }
}