package uoc.ei.ejemplos.modulo9.dns;


/**
 * Clase que contiene la informacin que define una direccin IP (ej: "100.23.98.255"). 
 * @author David Fguls
 * @author Jordi Alvarez (adaptacin para la versin 2.0.0 de la librera)
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */
public class IP implements Comparable{
  private String ip;
  
  /**
   * Constructor de una IP a partir de una cadena (ej "100.23.98.255").
   * @param s cadena que contiene la direccin IP(ej "100.23.98.255").
   */
  public IP(String s) {
    ip=s;
  }

  /**
   * Mtodo que permite comparar dos IP's. 
   * @param u otra IP.
   */
  public int compareTo(Object o) {
    IP i=(IP)o;
    return ip.compareTo(i.ip);
  }

  /**
   * Mtodo que retorna una cadena con la direccin ip.
   * @return String cadena con la direccin ip (ej "100.23.98.255").
   */
  public String toString() {
    return ip;
  }
}