package uoc.ei.ejemplos.modulo9.dns;

/**
 * Clase que agrupa la informacin necesaria que debemos guardar de cada host.<br>
 * Incluye el dominio, la direccin ip y el nmero de visitas.
 * @author David Fguls
 * @author Jordi Alvarez (adaptacin para la versin 2.0.0 de la librera)
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */
class InformacionHost {
  Dominio dominio;
  IP ip;
  int numVisitas;

  /**
   * Constructor a partir de un dominio y una ip. El contador de visitas se pone a 0.
   * @param d Dominio.
   * @param e IP.
   */
  public InformacionHost(Dominio d, IP i) {
    dominio=d;
    ip=i;
    numVisitas=0;
  }

  /**
   * Mtodo que incrementa el contador de visitas del host.
   */
  public void visita() {numVisitas++;}

  /**
   * Mtodo que retorna el Dominio del host.
   * @return Dominio el dominio del host.
   */
  public Dominio getDominio() {return dominio;}
  
  /**
   * Mtodo que retorna la direccin IP del host.
   * @return IP la direccin ip del host.
   */
  public IP getIP() {return ip;}

  /**
   * Mtodo que asigna la direccin IP del host.
   * @return IP la direccin ip del host.
   */
  public void setIP(IP i) {ip=i;}

  /**
   * Mtodo que retorna el nmero de visitas del host.
   * @return int nmero de visitas del host.
   */
  public int getVisitas() {return numVisitas;}
  
  
  public String toString() {
	  return "[InfoHost: "+dominio+","+ip+","+numVisitas+"]";
  }
}