package uoc.ei.ejemplos.modulo9.dns;

/**
 * Clase que contiene la informacin que define un Top Level Domain o TLD(ej: "edu"). 
 * @author David Fguls
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 1.0.0
 */
public class TLD implements Comparable{
  private String tld;

  /**
   * Constructor de un TLD a partir de una cadena (ej "edu").
   * @param s cadena que contiene el nmero del TLD (ej "edu").
   */
  public TLD(String s) {
    tld=s;
  }
  

  /**
  * Mtodo que permite comparar dos TLDs. 
  * @param u otro TLD.
  */
  public int compareTo(Object o) {
    TLD t=(TLD)o;
    return tld.compareTo(t.tld);
  }
  
  
  /** Calcula el hashcode del TLD. Delega en el mtodo
   * hashcode de String.
   */
  public int hashCode() {
	  return tld.hashCode();
  }
  

  /**
   * Mtodo que retorna una cadena con el nmero del TLD.
   * @return String cadena con el nmero del tld (ej "edu").
   */
  public String toString() {
    return tld;
  }
}