package uoc.ei.tads;
/**
 * Secuencia que se caracteriza porque se consulta y se borra el primero
 * elemento insertado: first-in-first-out (FIFO).
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */
public interface Cola<E>  extends Contenedor<E>
{
   /**
    * Aade un elemento a la cola, si ningn.
    * @param elem  elemento que se quiere aadir a la cola
    */
   public void encolar(E elem);

   /**
    * Borra el primer elemento de la cola, si hay alguno.
    * @exception ExcepcionContenedorVacio  si la cola est vaca
    * @return  primer elemento insertado en la cola
    */
   public E desencolar();

   /**
    * Accesor de lectura del primer elemento aadido a la cola, si hay.
    * @exception ExcepcionContenedorVacio  si la cola est vaca
    * @return  primer elemento de la cola
    */
   public E primero();
}
