package uoc.ei.tads;
/**
 * Clase que implementa la excepcin que se genera cuando se quiere obtener un
 * elemento de un contenedor que est vaco.
 *
 * Es una extensin de las excepciones en tiempo de ejecucin gestionadas por el
 * propio compilador.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */
public class ExcepcionContenedorVacio  extends ExcepcionTADs
{
   /** Atributo que en Java 1.5 determina la compatibilidad entre objetos
    * serialitzables de la misma clase. El identificador se calcula
    * mediante un mtodo de la clase Utilidades. */
   private static final long serialVersionUID = Utilidades.getSerialVersionUID();
	
	
   /** Constructor sin parmetros. */
   public ExcepcionContenedorVacio() { super(); }

   /**
    * Constructor con un parmetro.
    * @param mensaje  mensaje con el error que ha generado la excepcin
    */
   public ExcepcionContenedorVacio(String mensaje) { super(mensaje); }
}
