package uoc.ei.tads;
/**
 * Clase que implementa la excepcin que se genera cuando una clase no
 * implementa un mtodo por razones de eficiencia o seguridad.
 *
 * Es una extensin de las excepciones en tiempo de ejecucin gestionadas por el
 * propio compilador.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */
public class ExcepcionOperacionNoSoportada  extends ExcepcionTADs
{
   /** Atributo que en Java 1.5 determina la compatibilidad entre objetos
    * serialitzables de la misma clase. El identificador se calcula
    * mediante un mtodo de la clase Utilidades. */
   private static final long serialVersionUID = Utilidades.getSerialVersionUID();
	
	
   /** Constructor sin parmetros. */
   public ExcepcionOperacionNoSoportada() { super(); }

   /**
    * Constructor con un parmetro.
    * @param mensaje  mensaje con el error que ha generado la excepcin
    */
   public ExcepcionOperacionNoSoportada(String mensaje)
   {
      super(mensaje);
   }
}
