package uoc.ei.tads;
/**
 * Secuencia que se caracteriza porque se consulta y se borra el ltimo
 * elemento insertado: last-in-first-out (LIFO).
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */

public interface Pila<E>  extends Contenedor<E>
{
   /**
    * Aade un elemento a la pila, si cabe.
    * @param elem  elemento que se quiere aadir en la pila
    */
   public void apilar(E elem);

   /**
    * Borra el elemento de la cima de la pila, si hay alguno.
    * @exception ExcepcionContenedorVacio  si la pila est vaca
    * @return  elemento que haba en la cima de la pila
    */
   public E desapilar();

   /**
    * Accesor de lectura del ltimo elemento aadido en la pila, si hay.
    * @exception ExcepcionContenedorVacio  si la pila est vaca
    * @return  elemento de la cima de la pila
    */
   public E cima();
}
