package uoc.ei.tads;

import java.io.Serializable;

/**
 * Interfaz que representa una posicin de un contenedor. Una posicin es
 * el lugar que ocupa un elemento del contenedor y se define relativamente,
 * por ejemplo, en relacin con sus vecinos.
 * 
 * Las clases que lo implementen deben concretar la mencionada posicin
 * asocindole un nodo encadenado, el ndice de un vector, etc.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informacin,
 *          Universitat Oberta de Catalunya (UOC)
 * @version 2.0.0
 */
public interface Posicion<E> extends Serializable
{
   /**
    * Accessor de lectura del elemento almacenado a la posicin.
    * @return  elemento almacenado a la posicin
    */
   public E getElem();

}
